<app-spinner [show]="isLoading"></app-spinner>
<div class="d-flex align-items-center" style="height: 72px">
    <span class="normal_16px_22px_font text-black flex-fill">Allow to give full, to deny or to give partial permission to your staffs.</span>


    <button *appAccess="moduleName; lookFor: ['D', 'E']" mat-stroked-button (click)="resetAccess()">Reset</button>
    <button *appAccess="moduleName; lookFor: 'C'" mat-raised-button class="ml-2" (click)="addEditCustomRole()">Add
        custom Role
    </button>
</div>

<kendo-treelist
        class="remove-locked-col-border"
        [kendoTreeListFlatBinding]="data"
        [initiallyExpanded]="true"
        kendoTreeListExpandable
        idField="moduleId"
        parentIdField="parentModuleId"
        style="height: calc(100vh - 300px)"
>
    <kendo-treelist-column
            [expandable]="false"
            field="moduleDesc"
            title=" "
            [width]="5"
    >
    </kendo-treelist-column>
    <kendo-treelist-column
            [expandable]="true"
            class="module-name-col"
            field="moduleDesc"
            title=" "
            [width]="250"
            [locked]="true"
    >
        <ng-template
                kendoTreeListCellTemplate
                let-dataItem
        >
            <span
                    [class.font-weight-bold]="!dataItem.parentModuleId"
                    style="word-break: break-word; white-space: break-spaces;"
            >{{dataItem.moduleDesc}}</span>
        </ng-template>
    </kendo-treelist-column>
    <kendo-treelist-column
            *ngFor="let role of roles"
            [field]="role.field"
            [title]="role.roleName"
            [width]="250"
    >
        <ng-template
                kendoTreeListHeaderTemplate
                let-column
                let-columnIndex="columnIndex"
        >
            <div class="cursor-pointer" [class.custom-role]="role.isCustomRole"
                 (click)="role.isCustomRole && hasPermission(moduleName, ['E', 'D']) ? addEditCustomRole(role) : null">{{column.title}}</div>
        </ng-template>

        <ng-template
                kendoTreeListCellTemplate
                let-dataItem
                let-rowIndex="rowIndex"
        >
            <ng-template
                    [ngIf]="!dataItem.parentModuleId"
                    [ngIfElse]="childModules"
            >
                <div class="text-center">
                    <kendo-switch
                        #switch
                        class="small three-state"
                        [disabled]="!hasPermission(moduleName, 'E') || dataItem[role.field.split('.')[0]][role.field.split('.')[1]] && dataItem[role.field.split('.')[0]][role.field.split('.')[1]]['roleName'] == 'Owner'"
                        [checked]="dataItem[role.field.split('.')[0]][role.field.split('.')[1]] && dataItem[role.field.split('.')[0]][role.field.split('.')[1]]['moduleRoleAccess'] == FULL"
                        [class.intermediate]="dataItem[role.field.split('.')[0]][role.field.split('.')[1]] && dataItem[role.field.split('.')[0]][role.field.split('.')[1]]['moduleRoleAccess'] == PARTIAL"
                        [onLabel]="'Full'"
                        [offLabel]="' '"
                        (valueChange)="parentModuleValueChange(dataItem[role.field.split('.')[0]][role.field.split('.')[1]], $event, dataItem.moduleId, role, switch)"
                    >

                    </kendo-switch>
                </div>
            </ng-template>

            <ng-template
                #childModules
            >
                <div class="text-center">
                    <mat-button-toggle-group class="permissions-toggle-group" appearance="legacy" name="permissions"
                                             aria-label="Permissions"
                                             [disabled]="!hasPermission(moduleName, 'E') || dataItem[role.field.split('.')[0]][role.field.split('.')[1]] && dataItem[role.field.split('.')[0]][role.field.split('.')[1]]['roleName'] == 'Owner'"
                                             (change)="changeAccess($event, dataItem[role.field.split('.')[0]][role.field.split('.')[1]], dataItem.parentModuleId, role)"
                                             multiple>
                        <mat-button-toggle value="V"
                                           [checked]="dataItem[role.field.split('.')[0]][role.field.split('.')[1]] && dataItem[role.field.split('.')[0]][role.field.split('.')[1]]['modulePartialAccess'].includes('V')">
                            <mat-icon>visibility</mat-icon>
                        </mat-button-toggle>

                        <mat-button-toggle value="CE"
                                           [checked]="dataItem[role.field.split('.')[0]][role.field.split('.')[1]] && dataItem[role.field.split('.')[0]][role.field.split('.')[1]]['modulePartialAccess'].includes('C') && dataItem[role.field.split('.')[0]][role.field.split('.')[1]]['modulePartialAccess'].includes('E')">
                            <mat-icon>edit</mat-icon>
                        </mat-button-toggle>

                        <mat-button-toggle value="D"
                                           [checked]="dataItem[role.field.split('.')[0]][role.field.split('.')[1]] && dataItem[role.field.split('.')[0]][role.field.split('.')[1]]['modulePartialAccess'].includes('D')">
                            <mat-icon>delete</mat-icon>
                        </mat-button-toggle>
                    </mat-button-toggle-group>
                </div>
            </ng-template>
        </ng-template>


    </kendo-treelist-column>
</kendo-treelist>

<ng-template #resetConfirmation>
    <div style="padding-top: 20px;">
        <span>Permissions of all Roles will be reset to it's default state except for Custom Roles.</span>
    </div>
</ng-template>
